/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: AsTripleMarshaller.java,v e5d5eb7f1bd5 2010/06/24 17:09:42 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.semantic.io.json.spi.impl;

import javax.annotation.Nonnull;
import java.util.ArrayList;
import java.util.List;
import it.tidalwave.util.As;
import it.tidalwave.util.AsException;
import it.tidalwave.util.Displayable;
import it.tidalwave.semantic.io.json.Triple;
import it.tidalwave.semantic.io.json.impl.Vocabulary;
import it.tidalwave.semantic.io.json.spi.TripleMarshaller;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class AsTripleMarshaller implements TripleMarshaller
  {
    @Nonnull
    public List<Triple> marshal (final @Nonnull As entity)
      {
        final List<Triple> triples = new ArrayList<Triple>();
        triples.add(new Triple(entity, Vocabulary.RDF_ABOUT, Vocabulary.OWL_THING));
        triples.add(new Triple(entity, Vocabulary.RDF_ABOUT, Vocabulary.SKOS_CONCEPT));

        try
          {
            final Displayable displayable = entity.as(Displayable.class);
            // FIXME: for each language
            triples.add(new Triple(entity, Vocabulary.RDFS_LABEL, displayable.getDisplayName()));
          }
        catch (AsException e)
          {
            // never mind, it's not displayable
          }

        return triples;
      }
  }
